<template>
  <q-layout view="lHh Lpr lFf">
    <q-page-container>
      <q-page class="q-pa-sm bg-grey-2">
        <div
          class="col-xs-6 col-sm-6 col-md-4 col-lg-3 col-xl-2"
        >
          <q-card class="shadow-up-24 q-pb-xs">
            <q-card-section class="text-white bg-primary">
              <div
                class="text-h6"
                style="text-align: center"
              >
                Registro Basico
              </div>
            </q-card-section>
            <q-card-section>
              <div class="q-pa-sm row items-center justify-center">
                <div style="padding-right: 8px;" class="col-xs-12 col-sm-8 col-md-4 col-xl-4">
                  <q-input lazy-rules v-model="form.fullname" label="Apellidos" :error="$v.form.fullname.$error" error-message="Ingrese un nombre válido">
                    <q-tooltip>
                      Dato requerido *
                  </q-tooltip>
                  </q-input>
                </div>
                <div style="padding-right: 8px;" class="col-xs-12 col-sm-8 col-md-4 col-xl-4">
                  <q-input lazy-rules v-model="form.name"  label="Nombres" :error="$v.form.name.$error" error-message="Ingrese un nombre válido">
                    <q-tooltip>
                      Dato requerido *
                  </q-tooltip>
                  </q-input>
                </div>
                <div style="padding-right: 8px;" class="col-xs-12 col-sm-8 col-md-4 col-xl-4">
                  <q-input type="date" lazy-rules v-model="form.date"  label="Fecha de nacimiento" :error="$v.form.date.$error" error-message="Ingrese una Fecha válido">
                    <q-tooltip>
                      Dato requerido *
                  </q-tooltip>
                  </q-input>
                </div>
                <div style="padding-right: 8px;" class="col-xs-12 col-sm-8 col-md-4 col-xl-4">
                  <q-select
                    v-model="form.sexo"
                    :options="sexo"
                    label="Sexo"
                    option-value="value"
                    option-label="label"
                    emit-value
                    map-options
                    :error="$v.form.sexo.$error" error-message="Ingrese un Sexo válido"
                    >
                    <q-tooltip>
                      Dato requerido *
                  </q-tooltip>
                  </q-select>
                </div>
                <div v-if="form.pais === 'VEN'" style="padding-right: 8px;" class="col-xs-12 col-sm-8 col-md-4 col-xl-4">
                  <q-select
                    v-model="form.pais"
                    :options="pais"
                    label="Pais de Nacimiento"
                    option-value="value"
                    option-label="label"
                    emit-value
                    map-options
                    :error="$v.form.pais.$error" error-message="Ingrese un Pais"
                    >
                    <q-tooltip>
                      Dato requerido *
                  </q-tooltip>
                  </q-select>
                </div>
                <div v-if="form.pais !== 'VEN'" style="padding-right: 8px;" class="col-xs-12 col-sm-8 col-md-4 col-xl-4">
                  <q-input
                    v-model="form.pais"
                    label="Pais de Nacimiento"
                    :error="$v.form.pais.$error" error-message="Ingrese un Pais"
                    >
                    <q-tooltip>
                      Dato requerido *
                  </q-tooltip>
                  </q-input>
                </div>
                <div style="padding-right: 8px;" class="col-xs-12 col-sm-8 col-md-4 col-xl-4">
                  <q-input
                    v-model="form.dni"
                    label="Nº Documento"
                    :error="$v.form.dni.$error" error-message="Ingrese un DNI"
                    :mask="form.pais === 'VEN' ? 'V-########' : 'E-########'"
                    >
                    <q-tooltip>
                      Dato requerido *
                  </q-tooltip>
                  </q-input>
                </div>
                <div style="padding-right: 8px;" class="col-xs-12 col-sm-8 col-md-4 col-xl-4">
                  <q-select
                    v-model="form.carrera"
                    :options="carrera"
                    label="Carrera a Estudiar"
                    option-value="value"
                    option-label="label"
                    emit-value
                    map-options
                    :error="$v.form.carrera.$error" error-message="Ingrese una carrera"
                    >
                    <q-tooltip>
                      Dato requerido *
                  </q-tooltip>
                  </q-select>
                </div>
                <div style="padding-right: 8px;" class="col-xs-12 col-sm-8 col-md-4 col-xl-4">
                  <q-input type="email" lazy-rules v-model="form.email" :error="$v.form.email.$error" error-message="Ingrese un Email valido" label="Correo">
                    <q-tooltip>
                      Dato requerido *
                  </q-tooltip>
                  </q-input>
                </div>
              </div>
              <div>
                <q-btn-group spread unelevated push>
                <q-btn label="Atras" push class="bg-secondary text-white" icon="undo" @click="Back()"/>
                <q-btn @click="verify()" push class="bg-primary text-white" label="Enviar"/>
                </q-btn-group>
              </div>
            </q-card-section>
          </q-card>
          <template>
            <div class="q-pa-md q-gutter-sm">
              <q-dialog v-model="band" persistent transition-show="scale" transition-hide="scale">
                <q-card class="bg-teal text-white" style="width: 300px">
                  <q-card-section>
                    <div class="text-h6">Atencion</div>
                  </q-card-section>
                  <q-card-section class="q-pt-none">
                    Su informacion fue enviada a finanzas y control de estudios, una vez verificada rcibira un correo electronico con la respuesta correspondiente <br> <strong>Muchas gracias por escogernos</strong>
                  </q-card-section>
                  <q-card-actions aling="right" class="bg-white text-teal">
                    <q-btn flat label="Listo" @click="close()"/>
                  </q-card-actions>
                </q-card>
              </q-dialog>
            </div>
          </template>
        </div>
      </q-page>
    </q-page-container>
  </q-layout>
</template>
<script>
import { required, email } from 'vuelidate/lib/validators'
export default {
  data () {
    return {
      band: false,
      form: {
        date: '1998-09-25',
        pais: 'VEN'
      },
      sexo: [
        {
          label: 'Masculino',
          value: 'M'
        },
        {
          label: 'Femenino',
          value: 'F'
        }
      ],
      pais: [
        {
          label: 'Venezuela',
          value: 'VEN'
        },
        {
          label: 'Otro',
          value: 'E'
        }
      ],
      carrera: [
        {
          label: 'Informatica',
          value: 'Informatica'
        },
        {
          label: 'Admon Personal',
          value: 'Personal'
        },
        {
          label: 'Admon Empresas',
          value: 'Empresas'
        },
        {
          label: 'Educ Prescolar',
          value: 'Prescolar'
        },
        {
          label: 'P. Formacion Teologica',
          value: 'Teologia'
        }
      ]
    }
  },
  validations: {
    form: {
      name: {
        required
      },
      fullname: {
        required
      },
      date: {
        required
      },
      sexo: {
        required
      },
      pais: {
        required
      },
      carrera: {
        required
      },
      email: {
        required,
        email
      },
      dni: {
        required
      }
    }
  },
  methods: {
    Back (url) {
      this.$router.push('/')
    },
    verify () {
      this.$v.form.$touch()
      if (this.$v.form.$error) {
        console.log('error')
      } else {
        this.form.aprovated = 0
        this.$q.loading.show()
        this.$api.post('register', this.form).then(res => {
          this.band = true
          this.$root.$emit('notify')
          this.$q.loading.hide()
        })
      }
    },
    close () {
      this.band = false
      this.$router.push('/login')
    }
  }
}
</script>
